declare type LibraryDirType = string | ((compName: string) => string);
export interface Options {
    /** 默认@ad/r-ui */
    libraryName?: string;
    /** 拆分chunk的名字 */
    chunkNames?: {
        /** pc端chunk名，默认rui-pc */
        pc?: string;
        /** 移动端chunk名，默认rui-mobile */
        mobile?: string;
    };
    /** 对应端目录 */
    libraryDir?: {
        pc?: LibraryDirType;
        mobile?: LibraryDirType;
    };
    /** 组件有各自的chunk，默认false，即合并到两端各自的chunk中 */
    splitChunkByComp?: boolean;
    /** 详细说明，默认false */
    verbose?: boolean;
}
/**
 * 双端组件babel插件
 * 1. import React from 'react' => import React, { suspense, lazy } from 'react'
 * 2. import { useMobile, Button } from '@ad/r-ui' => import { useMobile } from '@ad/r-ui'
 * 3. 组件重新封装
 */
declare const _default: any;
export default _default;
