"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.entryVisitor = void 0;
var t = __importStar(require("@babel/types"));
var difference_1 = __importDefault(require("lodash/difference"));
var const_1 = require("./const");
// 确认要转换
var innerVisitor = {
    ImportDeclaration: function (path, state) {
        var plugin = state.plugin;
        if (!plugin)
            return;
        var _a = plugin.opts, libraryName = _a.libraryName, verbose = _a.verbose, log = plugin.log, getState = plugin.getState, updateState = plugin.updateState;
        // insert extra react Specifiers after last import
        if (!t.isImportDeclaration(path.getNextSibling()) && !getState().reactTransformed) {
            var extraSpecifiers = (0, difference_1["default"])(const_1.reactSpecifiersName, getState().reactSpecifiers.map(function (i) { return i.importName; }));
            if (extraSpecifiers.length) {
                path.insertAfter(t.importDeclaration(extraSpecifiers.map(function (n) {
                    return t.importSpecifier(t.identifier(n), t.identifier(n));
                }), t.stringLiteral('react')));
                updateState('reactTransformed', true);
            }
        }
        // collect react specifiers
        if (t.isStringLiteral(path.node.source, { value: 'react' }) && !getState().reactTransformed) {
            var specifiers_1 = path.node.specifiers.map(function (i) {
                var _a;
                return {
                    importName: (_a = i === null || i === void 0 ? void 0 : i.imported) === null || _a === void 0 ? void 0 : _a.name,
                    localName: i.local.name
                };
            });
            updateState('reactSpecifiers', function (prev) { return prev.concat(specifiers_1); });
        }
        // deal target library
        if (t.isStringLiteral(path.node.source, { value: libraryName })) {
            path.traverse({
                ImportSpecifier: function (path) {
                    var siblings = path.container.filter(function (i) { return t.isImportSpecifier(i); });
                    // add useMobile if necessary
                    if (!siblings.find(function (i) { var _a; return ((_a = i.imported) === null || _a === void 0 ? void 0 : _a.name) === const_1.ruiExtraSpecifier; })) {
                        path.insertAfter(t.importSpecifier(t.identifier(const_1.ruiExtraSpecifier), t.identifier(const_1.ruiExtraSpecifier)));
                    }
                    var importedName = path.node.imported.name;
                    var localName = path.node.local.name;
                    // 支持动态加载的组件，从原来的引用中删除，同时追加组件名
                    if (!const_1.ruiSpecifiersName.includes(importedName)) {
                        // assume need add component
                        var needAdd_1 = true;
                        path
                            .findParent(function (p) { return t.isProgram(p); })
                            .traverse({
                            VariableDeclaration: function (path) {
                                path.node.declarations.forEach(function (i) {
                                    var _a, _b, _c, _d;
                                    var obj = ((_a = i.init) === null || _a === void 0 ? void 0 : _a.object) || {};
                                    var property = (_b = i.init) === null || _b === void 0 ? void 0 : _b.property;
                                    if (
                                    // = Comp.XX
                                    (property && obj.name === localName) ||
                                        // { xx } = Comp
                                        (((_c = i.init) === null || _c === void 0 ? void 0 : _c.name) === localName && ((_d = i.id) === null || _d === void 0 ? void 0 : _d.type) === 'ObjectPattern')) {
                                        needAdd_1 = false;
                                        path.stop();
                                    }
                                });
                            },
                            // <Comp.XXX />
                            JSXMemberExpression: function (path) {
                                var _a, _b;
                                var obj = (_a = path.node) === null || _a === void 0 ? void 0 : _a.object;
                                var property = (_b = path.node) === null || _b === void 0 ? void 0 : _b.property;
                                if (property && obj.name === localName) {
                                    needAdd_1 = false;
                                    path.stop();
                                }
                            }
                        });
                        if (needAdd_1) {
                            plugin.updateState('compNames', function (prev) {
                                return prev.concat({
                                    importName: path.node.imported.name,
                                    localName: path.node.local.name
                                });
                            });
                            path.remove();
                        }
                    }
                }
            });
            log('transform components include:', plugin.getState().compNames);
            // after collecting compNames, begin overwrite
            plugin.overwriteComponents(path.findParent(function (i) { return i.isProgram(); }));
        }
    }
};
exports.entryVisitor = {
    ImportDeclaration: function (path, state) {
        var plugin = state.plugin;
        if (!plugin)
            return;
        var libraryName = plugin.opts.libraryName;
        if (t.isStringLiteral(path.node.source, { value: libraryName })) {
            if (path.node.specifiers
                .filter(function (i) { return t.isImportSpecifier(i); })
                .find(function (i) { return !const_1.ruiSpecifiersName.includes(i.imported.name); })) {
                path
                    .findParent(function (path) { return path.isProgram(); })
                    .traverse(innerVisitor, {
                    plugin: plugin
                });
            }
        }
    }
};
